//Root finding by Newton-Raphson
//
//The following code makes use of the Numerical technique of Finding a root called Newton-Raphson Method.
//
//The function sesolve requires four parameters:
//x0: Initial Guess(It should be somewhat near the root, though it is not always necessary)
//f: The equation whose root is to be estimated
//df: The derivative of the function f(define a function df which is the derivative of the equation whose root is to be estimated)
//tol: The tolerance value or the acceptable error in the root.
//
//NOTE: This method does not find all the roots but only One root near the initial guesses.
//
//To find different roots try using different initial guesses.
//
//The code does not work absolutely all the time for all equations and any inital guess, However with good initial guesses one can always get the answer.
//
//Reference: https://en.wikipedia.org/wiki/Newton%27s_method
//
//The code is a work in progress and any help/contribution is welcome.
//
funcprot(0);
function a=nrsolve(x0,f,df,tol)
    x1=x0-(f(x0)/df(x0));
    while abs(x1-x0)>=tol do
        x0=x1;
        x1=x0-(f(x0)/df(x0));
    end
    a=x1;
endfunction
